/*________________________________________________________________
  baback.c
  Ali J. Azarbayejani 30 December 1993 (originated)

  CONTENTS:

  DESCRIPTION:
  ________________________________________________________________*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/Label.h>
#include <Xm/Scale.h>
#include <Xm/TextF.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/extensions/Xvlib.h>
#include <X11/keysym.h>

#define FAILURE 1
typedef unsigned char uchar;

#define	VIDEO_WIDTH	640	/* Width of a video frame */
#define	VIDEO_MINW	142
#define	VIDEO_MAXW	640

#define	VIDEO_HEIGHT	480	/* Height of a video frame */
#define	VIDEO_MINH	105
#define	VIDEO_MAXH	490

#define	VIDEO_SEP	10	/* Separation between video & still windows */
#define VIDEO_BORDER	0	/* Video,still window borders */

#define	FORM_WIDTH	95
#define FORM_HEIGHT	110
#define BUTTON_WIDTH	75
#define	BUTTON_HEIGHT	40
#define BUTTON_LEFT	10
#define BUTTON_TOP	10
#define	BUTTON_HSP	(BUTTON_WIDTH + 5)
#define BUTTON_VSP	(BUTTON_HEIGHT + 10)

#define	FRNO_X		(FORM_WIDTH - 100)
#define FRNO_Y		30

#define DIR_FORWARD	0
#define DIR_BACK	1

struct myglobals {
  XtAppContext	context;
  Display	*dpy0;
  Display	*dpy1;

  Widget	toplevel;
  Widget	videoshell;
  Widget	videocore;
  Widget	videoform;

  Window	videowindow;

  XvPortID	port;
  XVisualInfo	*videovisual;
  XSetWindowAttributes attr;
  GC		videogc;
  Pixmap	videomap;
  int		videodepth;

  Widget	form;
  Widget	live;
  Widget	quit;
  Widget	digitize;

  GC		formgc;
  char		displayName[512];
} G

= { 0, NULL, NULL,
      0, 0, 0, 0,
      0,
      0, 0, 0, 0, 0, 0,
      0, 0, 0, 0,
      0
      };

/* void Live(); */
void Digitize(), Quit();
void live_video();

struct {
  int	verbose;
  char	*progname;
  char	*server;
  char	*outputFilename;
}

params = {
  0,
  "",
  "elephantcastle",
  "/bigtmp/babackImage.rgb"
};

void
  error( char *s )
{
  fprintf( stderr, "%s: FATAL ERROR %s\n", params.progname, s );
  exit(-1);
}

void
  alert( char *s )
{
  fprintf( stderr, "%s: %s\n", params.progname, s );
}

#define abort( string, rv ) { fprintf(stderr, "%s: %s\n", params.progname, string ); return (rv); }

void
  usage( int argc, char **argv )
{
  static char *flags = "[-v] [-server <hostname>] [-o <filename>]";
  static char *io    = "";
  static char *help  = "";

  fprintf( stderr, "usage: %s %s\n\t%s\n%s", argv[0], flags, io, help );
  exit(-1);
}

void
  parse_command_line( int argc, char **argv )
{
  int		i;

  params.progname = argv[0];

  for(i=1; i<argc; i++) {
    if( !strcmp(argv[i], "-v") )
      params.verbose = 1;
    else if( !strcmp(argv[i], "-server") )
      params.server = argv[++i];
    else if( !strcmp(argv[i], "-o") )
      params.outputFilename = argv[++i];
    else
      usage( argc, argv );
  }
  sprintf( G.displayName, "%s.media.mit.edu:0.1", params.server );
}

main(argc, argv)
  int argc;
  char *argv[];
{
  parse_command_line( argc, argv );

  G.toplevel = XtAppInitialize
    ( &G.context, "sequence", NULL, 0, &argc, argv, NULL, NULL, 0 );

  /* Have 2 displays */
  G.dpy0 = XtDisplay( G.toplevel );
  G.dpy1 = XtOpenDisplay
    (G.context,
     G.displayName,
     /* "elephantcastle.media.mit.edu:0.1", */
     "video_window",
     "Sequence",
     NULL,
     0,
     &argc,
     argv);

  /* Create a widget that can have video */
  verify_video_capability();

  G.videoshell = XtVaAppCreateShell
    ("Baback-CAM (TM)",
     "VideoWindow",
     applicationShellWidgetClass,
     G.dpy1, 
     XmNwidth, VIDEO_WIDTH,
     /* XmNheight, 2*VIDEO_HEIGHT + 2*VIDEO_SEP, */
     XmNheight, VIDEO_HEIGHT,
     XmNminWidth, VIDEO_MINW,
     XmNminHeight, VIDEO_MINH,
     XmNmaxWidth, VIDEO_MAXW,
     /* XmNmaxHeight, 2*VIDEO_MAXH + 2*VIDEO_SEP,*/
     XmNmaxHeight, VIDEO_MAXH,
     NULL);

  G.videoform = XtVaCreateManagedWidget
    ("video_form",
     xmFormWidgetClass, 
     G.videoshell,
     /* XmNheight, 2*VIDEO_HEIGHT + 2*VIDEO_SEP,*/
     XmNheight, VIDEO_HEIGHT,
     XmNwidth, VIDEO_WIDTH,
     NULL);

  G.videocore = XtVaCreateManagedWidget
    ("video_win",
     coreWidgetClass,  G.videoform,  
     XmNx, 0,
     XmNy, 0,
     XmNwidth, VIDEO_WIDTH,
     XmNheight, VIDEO_HEIGHT,
     NULL);

  XtPopup( G.videoshell, XtGrabNone );	/* Figure out what this does someday*/

  G.videowindow = XCreateWindow
    (G.dpy1,
     XtWindow( G.videocore ),
     0,	/* x */
     0,	/* y */
     VIDEO_WIDTH,
     VIDEO_HEIGHT,
     VIDEO_BORDER,
     G.videodepth,
     InputOutput,
     G.videovisual -> visual,
     CWColormap | CWBackPixel | CWBorderPixel | CWEventMask,
     &G.attr);

  XMapWindow( G.dpy1, G.videowindow );

  { /* Don't know what this does and why */
    XEvent evt;
    XGCValues gc_attr;

    while( !XCheckTypedEvent( G.dpy1, VisibilityNotify, &evt ) );

    gc_attr.foreground = 0xffffff;
    G.videogc = XCreateGC( G.dpy1, G.videowindow, GCForeground, &gc_attr );
  }

  G.videomap = XCreatePixmap
    ( G.dpy1, G.videowindow, VIDEO_WIDTH, VIDEO_HEIGHT, G.videodepth );

  /* Control Panel */
  G.form = XtVaCreateManagedWidget
    ("form",
     xmFormWidgetClass,
     G.toplevel,
     XmNwidth, FORM_WIDTH,
     XmNheight, FORM_HEIGHT,
     NULL);

  G.formgc = XCreateGC(G.dpy0, DefaultRootWindow( G.dpy0 ), 0, NULL );
  XSetBackground(G.dpy0, G.formgc, WhitePixel(G.dpy0, DefaultScreen(G.dpy0)));
  XSetForeground(G.dpy0, G.formgc, BlackPixel(G.dpy0, DefaultScreen(G.dpy0)));

#if 0
  G.live = XtVaCreateManagedWidget
    (">",
     xmPushButtonWidgetClass,
     G.form,
     XmNx, BUTTON_LEFT + 4 * BUTTON_HSP,
     XmNy, BUTTON_TOP + BUTTON_VSP,
     XmNwidth, BUTTON_WIDTH,
     XmNheight, BUTTON_HEIGHT,
     NULL);
  XtAddCallback( G.live, XmNactivateCallback, Live, 0 );
#endif

  G.digitize = XtVaCreateManagedWidget
    ("Grab",
     xmPushButtonWidgetClass,
     G.form,
     XmNx, BUTTON_LEFT,
     XmNy, BUTTON_TOP,
     XmNwidth, BUTTON_WIDTH,
     XmNheight, BUTTON_HEIGHT,
     NULL);
  XtAddCallback( G.digitize, XmNactivateCallback, Digitize, 0 );

  G.quit = XtVaCreateManagedWidget
    ("Quit",
     xmPushButtonWidgetClass,
     G.form,
     XmNx, BUTTON_LEFT,
     XmNy, BUTTON_TOP + BUTTON_VSP,
     XmNwidth, BUTTON_WIDTH,
     XmNheight, BUTTON_HEIGHT,
     NULL);
  XtAddCallback( G.quit, XmNactivateCallback, Quit, 0 );

  XtRealizeWidget(G.toplevel);
  XMapWindow( G.dpy0, XtWindow( G.form ) );
  live_video();
  XtAppMainLoop(G.context);
}

Status
  verify_video_capability( void )
{
  Window	root = DefaultRootWindow( G.dpy1 );
  int		screen = DefaultScreen( G.dpy1 );
  unsigned long	version, revision, adaptors;
  uint		major_opcode, error_base;
  XvAdaptorInfo *adaptor_info;
  XvFormat	*format;
  XVisualInfo	vis_info_temp;
  uint		vis_info_items;
  uint		base;
  Visual	*default_visual, *visual;

  if( FAILURE == XvQueryExtension
     (G.dpy1, &version, &revision, &major_opcode, &base, &error_base))
    abort( " Xv/video extension not available", 0 );

  XvQueryAdaptors( G.dpy1, root, &adaptors, &adaptor_info );

  if(!adaptors) {
    fprintf( stderr, "Display has no video adaptors.\n" );
    return;
  }
  format = adaptor_info->formats;

  G.videodepth = format->depth;
  G.port = adaptor_info->base_id;

  vis_info_temp.visualid = format->visual_id;

  G.videovisual = XGetVisualInfo
    ( G.dpy1, VisualIDMask, &vis_info_temp, &vis_info_items );

  if(!G.videovisual) {
    fprintf( stderr, "Could not find visual.\n" );
    return;
  }
#if 0
  Video_Capability_Verified = TRUE;
#endif

  /* Initialize video variables */
  default_visual = DefaultVisual( G.dpy1, screen );
  visual = G.videovisual->visual;

  G.attr.colormap = ( visual->visualid != default_visual->visualid ) ? 
    XCreateColormap(G.dpy1, root, visual, AllocNone) :
      DefaultColormap(G.dpy1, screen);

  G.attr.event_mask = VisibilityChangeMask;
  G.attr.background_pixel = 0x000000;
  G.attr.border_pixel = 0x000000;

#if 0
  Video_Color.hue = XInternAtom(G.dpy1, "XV_HUE", FALSE);
  Video_Color.saturation = XInternAtom(G.dpy1, "XV_SATURATION", FALSE);
  Video_Color.brightness = XInternAtom(G.dpy1, "XV_BRIGHTNESS", FALSE);
  Video_Color.contrast = XInternAtom(G.dpy1, "XV_CONTRAST", FALSE);
#endif
  return;
}

void
live_video()
{
  XvPutVideo(G.dpy1,
	     G.port,
	     G.videowindow,
	     G.videogc,
	     2, /* ?? */
	     2, /* ?? */
	     VIDEO_WIDTH,
	     VIDEO_HEIGHT,
	     0, /* x?? */
	     0, /* y?? */
	     VIDEO_WIDTH,
	     VIDEO_HEIGHT );
}

void
still_frame()
{
  XvStopVideo( G.dpy1, G.port, G.videowindow );
}

#if 0
void
 Live( Widget w, XtPointer client_data, XtPointer call_data )
{
  live_video();
}
#endif

void
  Quit( Widget w, XtPointer client_data, XtPointer call_data )
{
  exit(0);
}

void
  Digitize( Widget w, XtPointer client_data, XtPointer call_data )
{
  static uchar *buffer = NULL;
  static XImage *image = NULL;
  int j, k, l;
  uchar buf[ 3 * VIDEO_WIDTH ], *ucp;
  unsigned long pixelvalue;
  uchar red, green, blue;

  /* 
    Allocate if necessary
    */
  if( !image ) {
    image = XCreateImage
      (G.dpy1,
       G.videovisual -> visual,
       G.videodepth,
       ZPixmap,
       0,
       NULL,
       VIDEO_WIDTH,
       VIDEO_HEIGHT,
       8, /* pad */
       0); /* let computer compute */
    buffer = (uchar *) malloc( VIDEO_HEIGHT * image->bytes_per_line );
    image->data = buffer;
    if( !buffer || !image )
      error( "digitize: cannot allocate buffer" );
  }

  still_frame();

  /*
    Grab the picture
    */
  XGetSubImage
    (G.dpy1,
     G.videowindow,
     0, /* x */
     0, /* y */
     VIDEO_WIDTH,
     VIDEO_HEIGHT,
     AllPlanes,
     ZPixmap,
     image,
     0 /* x */,
     0 /* y */);
  for ( k = 0; k < VIDEO_HEIGHT; k++) {
    ucp = buf;
    for ( j = 0; j < VIDEO_WIDTH; j++ ) {
      pixelvalue = XGetPixel( image, j, k );
      *ucp++ = pixelvalue & image->red_mask;
      *ucp++ = (pixelvalue & image->green_mask) >> 8;
      *ucp++ = (pixelvalue & image->blue_mask) >> 16;
    }
    fwrite( buf, sizeof(uchar), VIDEO_WIDTH*3, stdout );
  }

  fprintf( stderr, " Wrote image\n");
  live_video();
  fflush( stdout );
}

