void make_coeffs(int in_ncol, int in_nrow, int ncol, int nrow, 
		 int residual_select, int neigframe,
		 float **image, float *coeffs, float ***eigimages);

void enroll(char imagefile[MAX_CHARS], char dir[MAX_CHARS], float *coeffs,
	    int neigframe);

int load_eigen(char eigdir[MAX_CHARS], int neigframe_select, 
	       int neigframe_in, int *neigframe,
	       float ****eigimages, int *nrow, int *ncol);

void load_known(Kface **kfaces, int *num_k_coeffs, int *num_k, 
	       char k_dir[MAX_CHARS]);

Matchptr add_match(Matchptr root, Matchptr new, int n);

int number_files(char list[]);

float find_distance(float *test, float *known, int no);

int neighbor(Kface *kfaces, int num_k_coeffs, int num_k, float *coeffs, 
	     char *closest[NUM_OF_NEIGHBORS]);

void write_float_as_uchar(image_t im, int M, int N, char filename[MAX_CHARS]);

imagparams_t ms_search(srchparams_t sparms, 
		       srchparams_t EIG_sparams,
		       srchparams_t MLD_sparams,
		       imagparams_t *best_MLD_imgparams,
		       int hier_flag, float **variances,
		       float **umap_musigma[MAX_NUM_TEMPLATES],
		       float **spatial_musigma[MAX_NUM_TEMPLATES],
		       float **eig_variances,
		       float **eig_umap_musigma[MAX_NUM_TEMPLATES],
		       float **eig_spatial_musigma[MAX_NUM_TEMPLATES],
		       float **w);

void scale_warp(srchparams_t sparms,
		int x_coord,
		int y_coord,
		float fscale,
		image_t scaledimage);

imagparams_t eig_search(srchparams_t sparms,
			int ***X_min,
			int ***Y_min,
			float ***ERR_min,
			int   **N_minima,
			float **variances,
			float **umap_musigma[MAX_NUM_TEMPLATES],
			float **spatial_musigma[MAX_NUM_TEMPLATES],
			float **w,
			int *num_minima);

imagparams_t ml_detect(srchparams_t sparms,
		       int **X_min,
		       int **Y_min,
		       float **ERR_min,
		       int *Nmin);

void model_warp(imagparams_t iparms,
		srchparams_t sparms,
		image_t warpedimage);

void model_warp_2(imagparams_t iparams, srchparams_t sparams, 
		  image_t ret_image, int ret_nrow, int ret_ncol);

void contrast_map(srchparams_t sparms,
		  image_t ret_image);

void pipe(srchparams_t MS_sparams,
	  float **ms_variances, float **ms_umap_musigma[MAX_NUM_TEMPLATES],
	  float **ms_spatial_musigma[MAX_NUM_TEMPLATES],
	  srchparams_t EIG_sparams, float **eig_variances,
	  float **eig_umap_musigma[MAX_NUM_TEMPLATES],
	  float **eig_spatial_musigma[MAX_NUM_TEMPLATES],
	  float **w,
	  srchparams_t MLD_sparams, 
	  float **image_out, char filename[MAX_CHARS], float **mask, 
	  int de_flag, int hier_flag);

imagparams_t 
pipe_locate(srchparams_t MS_sparams, 
	    float **ms_variances, float **ms_umap_musigma[MAX_NUM_TEMPLATES],
	    float **ms_spatial_musigma[MAX_NUM_TEMPLATES],
	    srchparams_t EIG_sparams, float **eig_variances, 
	    float **eig_umap_musigma[MAX_NUM_TEMPLATES], 
	    float **eig_spatial_musigma[MAX_NUM_TEMPLATES], float **w,
	    srchparams_t MLD_sparams, image_t image_out,
	    char filename[MAX_CHARS], float **mask, int de_flag, int hier_flag);

void normalise_face(srchparams_t MLD_sparams, imagparams_t MLD_imgparams, 
		    float **mask, image_t image_out );

void mask_image(image_t image, float **mask);

int compare(struct Point **p1, struct Point **p2);

void minima(float **A, int imin, int imax, int jmin, int jmax,
	    struct Points *Ps);

int contrast(float **image_in, float **image_out, 
	      int nrow, int ncol,
	      float pedestal, float scale,
	      float *mean, float *sigma);

float dffs(float *patch, int N, float **eigvectors, int first, int last);

float mahalanobis(float *patch, int N, float **eigvectors, float *eigvalues,
		  int first, int last);

float graymap(float *patch, int N);

float unitmap(float *patch, int N);

void statistics(float *p, int N, float *mean, float *sigma);

float norm_corr(float *patch, int N,
		float *template, float t_mean, float t_sigma);


float umap_musigma_distance(float mean, float sigma, float **umap_musigma);

float mahalanobis_distance(float *x, int N, float *Mu, float **inv_Sigma);

float local_mahalanobis_distance(float *x, int N, float *Mu, 
				 float **inv_Sigma);

void video_init();

void get_video_image(float *image, char filename[MAX_CHARS], int de_flag);

void best_minimum(int imin, int imax, int jmin, int jmax,
		  int *rowm, int *colm, float *error,
		  float **errormap, float scale);


int check_minimum(float **errormap, int i, int j);

void pop(float error_list[HIER_TOP_N], 
	 int rowm_list[HIER_TOP_N], 
	 int colm_list[HIER_TOP_N],
	 float scale_list[HIER_TOP_N],
	 int s_list[HIER_TOP_N],
	 float num, 
	 int i,
	 int j,
	 float scale,
	 int s);
