

#ifndef GRAB_H
#define GRAB_H

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/Xvlib.h>

/****** globals for Xv ********/
Display *_Xv_Video_Dpy;
XvPortID _Xv_Port;
Window root, _Xv_Main_Win;
GC _Xv_Video_GC;
unsigned long _Xv_Video_Depth;
Visual *_Xv_Visual;


#define F2C(f) ((char)((unsigned char)((f>255)?255:((f<0)?0:f))))

#define F2UC(f) ((unsigned char)((f>255)?255:((f<0)?0:f)))


/********* for Xv compatibility *******/
/*
void XvPutStilljw(Display *dpy, XvPortID port, Window win, GC gc,
		  int src_x, int src_y, int src_xdim, int src_ydim,
		  int dest_x, int dest_y, int dest_xdim, int dest_ydim);
*/



/***************************** grab.c ***************************************/

/**** initialize grabber: create video window and put video in it *******/
int grabber_init(int argc, char **argv,int xdim, int ydim);

/**** get from video and put in float or byte array ***/
int get_image_video_uc(unsigned char *im, int xdim,int ydim,int interlace);


/**** get from video and put in float array ***/
int get_image_video_f(float *im, int xdim,int ydim,int interlace);

/**** get from video and put in unsigned char array ***/
int get_image_video(void *im, int xdim, int ydim, char *type, int interleave);

/*** rgb to y conversion ***/
int rgb2y(float *r, float *g, float *b,
	  float *y, int xdim, int ydim);

/* create an ouput window */
Window CreateOutWin(int xdim, int ydim);

/* put a float image into win */
int put_image_video(float *im, int xdim, int ydim, Window win);

#endif








