/*---------------------------------------------------------------------------

  Program Name:  enroll.c
  Purpose:       Writes the coefficients for an image into a file
                 
  Author:        David Becker
  Date:          Oct. 5, 1994

-----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include "defines.h"
#include "util.h"
#include "io.h"
#include "matrix.h"
#include "affine.h"
#include "convolve.h"
#include "functions.h"
#include "faces.h"

void enroll(char imagefile[MAX_CHARS], char dir[MAX_CHARS], float *coeffs,
	    int neigframe)
{
  FILE *fp;
  int   c;
  char  filename[MAX_CHARS];

  sprintf(filename,"%s/%s",dir,imagefile);
  if ((fp = fopen(filename,"w")) == NULL)
    myerror("Could not open the output file for the coefficients");
  for (c = 1; c < neigframe; c++)
    fprintf(fp,"%f\n", coeffs[c]);
  fclose(fp);

}
    
