/*---------------------------------------------------------------------------

  Program Name:  pipe_neighbor.c
  Purpose:       functionfor taking coefficients and
                 figuring out which among known faces has closest set
                 of coefficients.
                 
  Author:        Dave Becker
                 Wasiuddin Wahid
  Date:          Sept. 26, 1994

-----------------------------------------------------------------------------*/


#include <stdio.h>
#include <malloc.h>
#include "defines.h"
#include "util.h"
#include "io.h"
#include "matrix.h"
#include "affine.h"
#include "convolve.h"
#include "functions.h"
#include "faces.h"

int neighbor(Kface *kfaces, int num_k_coeffs, int num_k, float *coeffs, 
	     char *closest[NUM_OF_NEIGHBORS])

{
  
  int       dist_coeffs;
  int       c;
  Tface    *face;
  Matchptr  a_match;
  float     dist;

  if (num_k_coeffs < NUM_COEFFS)
    dist_coeffs = num_k_coeffs;
  else
    dist_coeffs = NUM_COEFFS;
  face = (Tface *) malloc(sizeof(Tface));
  face->similar = (Matchptr) malloc(sizeof(Matchptr));
  face->similar = NULL;
  for (c = 0; c < num_k; c++)
    {
      dist = find_distance(coeffs,kfaces[c].coeffs,dist_coeffs);
      a_match = (Matchptr) calloc(1,sizeof(Match));
      a_match->name = (char *) malloc(strlen(kfaces[c].name) +1);
      strcpy(a_match->name,(kfaces[c]).name);
      a_match->distance = dist;
      a_match->next = (Matchptr) malloc(sizeof(Matchptr));
      a_match->next = NULL;
      face->similar = add_match(face->similar, a_match, c);
    }
  
  for (c = 0; c < NUM_OF_NEIGHBORS; c++)
    {
      closest[c] = (char *) malloc(strlen((face->similar)->name)+1);
      strcpy(closest[c],(face->similar)->name);
      face->similar = (face->similar)->next;
    }
  return 0;

}









