/*---------------------------------------------------------------------------

  Program Name:  pop.m
  Purpose:       This simply is used to insert numbers into a top-N
		 list of errors in order to pick out the N best heads
                 from ms_eigsearch.

  Author:        David Becker (dbecker@media.mit.edu)
  Date:          Nov. 21, 1994

-----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <float.h>
#include "defines.h"
#include "util.h"
#include "io.h"
#include "matrix.h"
#include "affine.h"
#include "convolve.h"
#include "functions.h"
#include "faces.h"

void pop(float error_list[HIER_TOP_N], 
	 int rowm_list[HIER_TOP_N], 
	 int colm_list[HIER_TOP_N],
	 float scale_list[HIER_TOP_N],
	 int s_list[HIER_TOP_N],
	 float num, 
	 int i,
	 int j,
	 float scale,
	 int s)

{

  int c = 0, n;

  while (num > error_list[c])
    c++;
  for (n = HIER_TOP_N-1; n > c; n--)
    {
      error_list[n] = error_list[n-1];
      rowm_list[n] = rowm_list[n-1];
      colm_list[n] = colm_list[n-1];
      scale_list[n] = scale;
      s_list[n] = s;
    }
  error_list[c] = num;
  rowm_list[c] = (int) (i/scale + 0.5);
  colm_list[c] = (int) (j/scale + 0.5);
  scale_list[c] = scale;
  s_list[c] = s;

}
