#define SCALEBY 0.354

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include "defines.h"
#include "util.h"
#include "io.h"
#include "matrix.h"
#include "affine.h"
#include "convolve.h"
#include "functions.h"
#include "faces.h"


/*--------------------------------------------------------------------*/

int main(int argc, char *argv[])
{

  int           i,j,res;
  image_t       orig_im, scaled_im;
  float         **Warp;

  orig_im = matrix(1, 192, 1, 128);
  scaled_im = matrix(1,192,1,128);
  Warp = matrix(1, 3, 1, 3);

  /* ------ apply scaling to image_orig ------ */
  for (i=1; i<=3; i++)
    for (j=1; j<=3; j++)
      Warp[i][j] = 0.0;
  Warp[1][1] = Warp[2][2] = SCALEBY;
  Warp[3][3] = 1.0;

  read_RAW("testim1",orig_im,192,128);
  write_float_as_uchar(orig_im,192,128,"junk0.raw");

  res = affine_warp(orig_im, scaled_im, 192, 128, Warp, 0.0);
  write_float_as_uchar(scaled_im,192,128,"junk1.raw");
  printf("Warp 1, levels=%d\n",res);
/*
  res = affine_warp(scaled_im, orig_im, 192, 128, Warp, 0.0);
  write_float_as_uchar(orig_im,192,128,"junk2.raw");
  printf("Warp 2, levels=%d\n",res);

  res = affine_warp(orig_im, scaled_im, 192, 128, Warp, 0.0);
  write_float_as_uchar(scaled_im,192,128,"junk3.raw");
  printf("Warp 3, levels=%d\n",res);
*/
  free_matrix(orig_im, 1, 192, 1, 128);
  free_matrix(scaled_im, 1, 192, 1, 128);
  free_matrix(Warp, 1, 3, 1, 3);
}

/*--------------------------------------------------------------------*/
