/*---------------------------------------------------------------------------

  Program Name:  timestamp.c
  Purpose:       Give timings at various stages of execution.

  Author:        Mark Shackleton (BT)

  Date:          June 19, 1995

-----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <time.h>
#include "defines.h"

void timestamp(char *label)
{
    static int            called = FALSE;
    static unsigned int   first_time, last_time;
    unsigned long         time_now, time_delta, cum_secs;

/*    return;   /* skip for now */

    time_now = (long)time(NULL);

    if (!called) {
        first_time = last_time = time_now;
	fprintf(stderr,"Time clock initialised (%s)\n",label);
	called = TRUE;
        return;
    }

    time_delta = time_now - last_time;
    cum_secs = time_now - first_time;

    fprintf(stderr,"Cumulative=%04ds (%02d:%02d); Delta=%04ds; %s\n",
	    cum_secs, cum_secs/60, cum_secs%60, time_delta, label);

    last_time = time_now;
} 
      
/*-----------------------------------------------------------------------------*/

