/* This function takes a float array and writes it to disk as uchar */


#include <stdio.h>
#include <malloc.h>
#include "defines.h"
#include "util.h"
#include "io.h"
#include "matrix.h"
#include "affine.h"
#include "convolve.h"
#include "functions.h"
#include "faces.h"

void write_float_as_uchar(image_t im, int M, int N, char filename[MAX_CHARS])

{
  int c1, c2;
  unsigned char **temp_im;

  temp_im = cmatrix(1,M,1,N);
  for (c1 = 1; c1 <= M; c1++)
    for (c2 = 1; c2 <= N; c2++)
      temp_im[c1][c2] = (unsigned char) im[c1][c2];

  write_RAW(filename,temp_im,M,N);

  free_cmatrix(temp_im,1,M,1,N);

}
