/*----------------------------------------------------------------------
PROGRAM: test_ascii.c
DATE:    5/5/94
AUTHOR:  Baback Moghaddam, baback@media.mit.edu
------------------------------------------------------------------------


   This routine reads in an ASCII file of the format

   filename  
   .
   .
   .

   and applies the filter to each image in the input directory,
   the resulting filtered images are written to the output directory 
   under the same names.
   

---------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <float.h>
#include "util.h"
#include "io.h"




/* ----------- Command-Line Parsing Stuff ------- */

extern int optind;
extern char *optarg;
char *progname;          /* used to store the name of the program  */
char comline[256];       /* used to store the entire command line  */

#define OPTIONS "i:"

char *usage = "-i infile  \n";


#define MAX_CHARS  256

/*----------------------------------------------------------------------*/


main(int argc, char **argv)
{

 
  register int i,j,k,l,ii,jj;
  int f, c, nframe, nfeatures, sets, bytes_pixel;
  int nrow, ncol, M, N;
  char command[MAX_CHARS],indir[MAX_CHARS],listfile[MAX_CHARS], \
    infile[MAX_CHARS], filterfile[MAX_CHARS],outdir[MAX_CHARS], \
      filename[MAX_CHARS], line[MAX_CHARS];



  int Frow, Fcol;
  float **F; 

  float fval1, fval2, fval;
  FILE *fp, *fp2;         /* for output values dump */


  /* required input flags */
  
  int errflag   = 0;
  int inflag    = 0;




  progname = argv[0];
  for (i=0; i<argc; i++)
    strcat(comline, argv[i]),strcat(comline, " ");
  
  
  /* ----------------------  Command Line Parse ------------------------ */
  
  while ((c = getopt(argc, argv, OPTIONS)) != EOF)
    switch (c) {
      
    case 'i':
      strcpy(infile, optarg);
      inflag = 1;
      break;
    
    case '?':
      errflag = 1;
      break;
    }


  /* command line error check */
  
  if (errflag || !inflag) {
    fprintf(stderr,"\nUSAGE: %s %s\n%s\n", progname, usage);
    exit(1);
  }


  /* ----  read indir descriptor file -------- */
  
  if (get_ASCII_dimensions(infile, &nrow, &ncol) != 0) {
    F = matrix(1, nrow, 1, ncol);
    if (read_ASCII(infile, F, nrow, ncol) != 0) {
      printf("Data: \n\n");
      for (i=1; i<=nrow; i++) {
	for (j=1; j<=ncol; j++) 
	  printf("%+1.6g  ", F[i][j]);
	printf("\n");
      }
    }
    else
      printf("read_ASCII error! \n");
  }
  else
    printf("get_ASCII_dimensions error! \n");

  printf("nrow = %d, ncol = %d\n", nrow, ncol);

  return 0;
}






